Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/extrema.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/extrema.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/extrema.cpp	(revision 12878)
@@ -9,6 +9,7 @@
 #endif
 
+#include "../../include/include.h"
 
-double min(double a,double b){
+IssmDouble min(IssmDouble a,IssmDouble b){
 	if (a<b)return a;
 	else return b;
@@ -18,5 +19,5 @@
 	else return b;
 }
-double max(double a,double b){
+IssmDouble max(IssmDouble a,IssmDouble b){
 	if (a>b)return a;
 	else return b;
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/isnan.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/isnan.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/isnan.cpp	(revision 12878)
@@ -1,9 +1,10 @@
 /*This routine only used by Intel compler: */
-#ifdef _INTEL_WIN_
 
-int isnan(double x){
-	if (x!=x)return 1;
-	else return 0;
+#include "../../include/include.h"
+#include "isnan.h"
+
+#ifdef _HAVE_ADOLC_
+template <> int xIsNan<adouble> (const adouble& X) {
+  return isnan(X.getValue());
 }
 #endif
-
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/isnan.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/isnan.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/isnan.h	(revision 12878)
@@ -3,11 +3,20 @@
  */ 
 
-#ifndef _ISNAN_INTEL_H_
-#define _ISNAN_INTEL_H_
+#ifndef _XISNAN_H_
+#define _XISNAN_H_
 
+#include <cmath>
+
+template <class T> int xIsNan(const T& X) {
 #ifdef _INTEL_WIN_
-int isnan(double X);
+		return (X!=X)?1:0;
+#else
+		return isnan(X);
+#endif
+}
+
+#ifdef _HAVE_ADOLC_
+template <> int xIsNan<adouble> (const adouble& X);
 #endif
 
 #endif
-
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/numerics.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/numerics.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/numerics.h	(revision 12878)
@@ -9,4 +9,5 @@
 #include "./GaussPoints.h"
 #include "./isnan.h"
+#include "./recast.h"
 
 class Input;
@@ -16,17 +17,17 @@
 struct OptPars;
 
-double min(double a,double b);
-double max(double a,double b);
+IssmDouble min(IssmDouble a,IssmDouble b);
+IssmDouble max(IssmDouble a,IssmDouble b);
 int    min(int a,int b);
 int    max(int a,int b);
-double OptFunc(double scalar, OptArgs* optargs);
-void   BrentSearch(double* psearch_scalar,double* pJ,OptPars* optpars,double (*f)(double,OptArgs*), OptArgs* optargs);
-void   OptimalSearch(double* psearch_scalar,double* pJ,OptPars* optpars,double (*f)(double,OptArgs*), OptArgs* optargs);
-void   cross(double* result,double* vector1,double* vector2);
-void   IsInputConverged(double* peps, Input** new_inputs,Input** old_inputs,int num_inputs,int criterion_enum);
-void   UnitConversion(double* values, int numvalues,int direction_enum, int type_enum);
-double UnitConversion(double value, int direction_enum, int type_enum);
+IssmDouble OptFunc(IssmDouble scalar, OptArgs* optargs);
+void   BrentSearch(IssmDouble* psearch_scalar,IssmDouble* pJ,OptPars* optpars,IssmDouble (*f)(IssmDouble,OptArgs*), OptArgs* optargs);
+void   OptimalSearch(IssmDouble* psearch_scalar,IssmDouble* pJ,OptPars* optpars,IssmDouble (*f)(IssmDouble,OptArgs*), OptArgs* optargs);
+void   cross(IssmDouble* result,IssmDouble* vector1,IssmDouble* vector2);
+void   IsInputConverged(IssmDouble* peps, Input** new_inputs,Input** old_inputs,int num_inputs,int criterion_enum);
+void   UnitConversion(IssmDouble* values, int numvalues,int direction_enum, int type_enum);
+IssmDouble UnitConversion(IssmDouble value, int direction_enum, int type_enum);
 char*  OptionsFromAnalysis(Parameters* parameters,int analysis_type);
-void   XZvectorsToCoordinateSystem(double* T,double* xzvectors);
+void   XZvectorsToCoordinateSystem(IssmDouble* T,IssmDouble* xzvectors);
 #ifdef _HAVE_PETSC_
 void   PetscOptionsFromAnalysis(Parameters* parameters,int analysis_type);
Index: issm/branches/trunk-jpl-damage/src/c/shared/Numerics/recast.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Numerics/recast.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Numerics/recast.h	(revision 12878)
@@ -0,0 +1,39 @@
+/*
+ * recast.h
+ *
+ *  Created on: Jun 26, 2012
+ *      Author: utke
+ */
+
+#ifndef _RECAST_H_
+#define _RECAST_H_
+
+#ifndef _HAVE_ADOLC_
+
+template<class To, class From>
+To reCast(const From& from) {
+    return (To)from;
+}
+
+#else
+
+template<class To, class From>
+struct ForPartialSpecialization {
+    static  To reCast(const From& from ) { return (To) from;}
+};
+
+template<class To, class From>
+To reCast(const From& from) {
+    return ForPartialSpecialization<To,From>::reCast(from);
+}
+/**
+ * partial specialization
+ */
+template<class To>
+struct ForPartialSpecialization<To,adouble> {
+    static  To reCast(const adouble& from ) { return (To) (from.getValue());}
+};
+
+#endif
+
+#endif
Index: issm/branches/trunk-jpl-damage/src/c/shared/String/DescriptorIndex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/String/DescriptorIndex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/String/DescriptorIndex.cpp	(revision 12878)
@@ -23,10 +23,10 @@
 	/*retrieve first token, separated by underscore: */
 	pch = strtok (descriptor,"_");
-	if(!pch)_error_("%s%s%s"," descriptor ",descriptor," is not correctly formatted!");
+	if(!pch)_error2_("descriptor " << descriptor << " is not correctly formatted!");
 
 	if (strncmp(pch,"scaled",6)==0){
 		/*we have a scaled variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," scaled descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("scaled descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 
@@ -44,9 +44,9 @@
 		/*we have an indexed variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," indexed descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("indexed descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 		/*now recover  the index: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," indexed descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("indexed descriptor " << descriptor << " is not correctly formatted!");
 		sscanf(pch,"%i",pindex);
 		return IndexedEnum;
@@ -55,9 +55,9 @@
 		/*we have an indexed variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," nodal descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("nodal descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 		/*now recover  the index: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," nodal descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("nodal descriptor " << descriptor << " is not correctly formatted!");
 		sscanf(pch,"%i",pindex);
 		return NodalEnum;
Index: issm/branches/trunk-jpl-damage/src/c/shared/Sys/ProfilingEnd.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Sys/ProfilingEnd.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Sys/ProfilingEnd.cpp	(revision 12878)
@@ -0,0 +1,43 @@
+/*!\file:  ProfilingEnd.cpp
+ * \brief ProfilingEnd.c: finalize profiling after calling a routine. Needs to mirror a ProfilingStart routine.
+ */
+
+/*Include files: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+#include "../../include/macros.h"
+#include "../shared.h"
+#include "../../io/io.h"
+/*}}}*/
+
+void ProfilingEnd(double* pSolution_time, double* pMemory_use, double* pCurrent_flops, double Time_start, double Flops_start){
+
+	double Solution_time, Memory_use, Current_flops;
+	double Time_finish, Flops_finish, memUse;
+	
+	#ifdef _HAVE_PETSC_
+	PetscGetTime(&Time_finish);
+	PetscGetFlops(&Flops_finish);
+	PetscMemoryGetCurrentUsage(&memUse);
+	
+	Solution_time=Time_finish-Time_start;
+	Current_flops=Flops_finish-Flops_start;
+	_pprintLine_("PETSc elapsed time  : " << Solution_time << "  Seconds");
+	_pprintLine_("PETSc elapsed flops : " << Current_flops << "  Flops");
+	_pprintLine_("PETSc memory used   : " << memUse << "  Bytes");
+	#else
+		_error_("Profiling not supported under this numerical toolkit");
+	#endif
+
+	/*Assign pointers: */
+	*pSolution_time=Solution_time;
+	*pMemory_use=memUse;
+	*pCurrent_flops=Current_flops;
+	return;
+}
+
+
+
Index: issm/branches/trunk-jpl-damage/src/c/shared/Sys/ProfilingStart.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Sys/ProfilingStart.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Sys/ProfilingStart.cpp	(revision 12878)
@@ -0,0 +1,32 @@
+/*!\file:  ProfilingStart.cpp
+ * \brief ProfilingStart.c: initialize profiling before calling a routine
+ */
+
+
+/*Include files: {{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+#include "../../include/macros.h"
+#include "../shared.h"
+#include "../../io/io.h"
+/*}}}*/
+
+void ProfilingStart(double* pTime_start, double* pFlops_start){
+	
+	double Time_start, Flops_start;
+	
+	#ifdef _HAVE_PETSC_
+		PetscGetTime(&Time_start);
+		PetscGetFlops(&Flops_start );
+	#else
+		_error_("Profiling not supported under this numerical toolkit");
+	#endif
+
+	/*Assign pointers: */
+	*pTime_start=Time_start;
+	*pFlops_start=Flops_start;
+	return;
+}
Index: issm/branches/trunk-jpl-damage/src/c/shared/Sys/sys.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Sys/sys.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Sys/sys.h	(revision 12878)
@@ -0,0 +1,12 @@
+/* \file sys.h
+ * \brief: header file for ISSM system routines (profiling, timing, etc ...)
+ */
+
+
+#ifndef _ISSM_SYS_H_
+#define _ISSM_SYS_H_
+
+void ProfilingEnd(double* pSolution_time, double* pMemory_use, double* pCurrent_flops, double Time_start, double Flops_start);
+void ProfilingStart(double* pTime_start, double* pFlops_start);
+
+#endif
Index: issm/branches/trunk-jpl-damage/src/c/shared/Threads/LaunchThread.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Threads/LaunchThread.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Threads/LaunchThread.cpp	(revision 12878)
@@ -20,5 +20,5 @@
 
 #include "./issm_threads.h"
-#include "../Alloc/alloc.h"
+#include "../Alloc/xNewDelete.h"
 #include "../Exceptions/exceptions.h"
 #include "../../include/include.h"
@@ -28,12 +28,11 @@
 	#ifdef _MULTITHREADING_
 	int i;
-	int* status=NULL;
-
-	pthread_t* threads=NULL;
-	pthread_handle* handles=NULL;
+	int            *status  = NULL;
+	pthread_t      *threads = NULL;
+	pthread_handle *handles = NULL;
 	
 	/*dynamically allocate: */
-	threads=(pthread_t*)xmalloc(num_threads*sizeof(pthread_t));
-	handles=(pthread_handle*)xmalloc(num_threads*sizeof(pthread_handle));
+	threads=xNew<pthread_t>(num_threads);
+	handles=xNew<pthread_handle>(num_threads);
 
 	for(i=0;i<num_threads;i++){
@@ -42,20 +41,19 @@
 		handles[i].num=num_threads;
 	}
-	
 	for(i=0;i<num_threads;i++){
 
 		if(pthread_create(threads+i,NULL,function,(void*)(handles+i))){
-			_error_(" pthread_create error");
+			_error2_("pthread_create error");
 		}
 	}
 	for(i=0;i<num_threads;i++){
 		if(pthread_join(threads[i],(void**)&status)){
-			_error_(" pthread_join error");
+			_error2_("pthread_join error");
 		}
 	}
 	
 	/*Free ressources:*/
-	xfree((void**)&threads);
-	xfree((void**)&handles);
+	xDelete<pthread_t>(threads);
+	xDelete<pthread_handle>(handles);
 
 	#else
@@ -67,4 +65,3 @@
 	function((void*)&handle);
 	#endif
-
 }
Index: issm/branches/trunk-jpl-damage/src/c/shared/TriMesh/SplitMeshForRifts.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/TriMesh/SplitMeshForRifts.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/TriMesh/SplitMeshForRifts.cpp	(revision 12878)
@@ -3,5 +3,5 @@
  */
 #include "./trimesh.h"
-
+#include "../Alloc/xNewDelete.h"
 #include "../Alloc/alloc.h"
 
@@ -52,5 +52,5 @@
 
 	/*Go through all nodes of the rift segments, and start splitting the mesh: */
-	flags=(int*)xcalloc(nods,sizeof(int)); //to make sure we don't split the same nodes twice!
+	flags=xNewZeroInit<int>(nods); //to make sure we don't split the same nodes twice!
 	for (i=0;i<nriftsegs;i++){
 		for (j=0;j<2;j++){
Index: issm/branches/trunk-jpl-damage/src/c/shared/TriMesh/TriMeshUtils.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/TriMesh/TriMeshUtils.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/TriMesh/TriMeshUtils.cpp	(revision 12878)
@@ -7,4 +7,5 @@
 #include "./trimesh.h"
 #include "../Exceptions/exceptions.h"
+#include "../Alloc/xNewDelete.h"
 #include "../Alloc/alloc.h"
 #include "../../include/include.h"
@@ -53,5 +54,5 @@
 	current_size=max_number_elements;
 	NumGridElements=0;
-	GridElements=(int*)xmalloc(max_number_elements*sizeof(int));
+	GridElements=xNew<int>(max_number_elements);
 
 	for (i=0;i<nel;i++){
@@ -65,5 +66,5 @@
 				else{
 					/*Reallocate another max_number_elements slots in the GridElements: */
-					GridElementsRealloc=(int*)xrealloc(GridElements,(current_size+max_number_elements)*sizeof(int));
+					GridElementsRealloc=xReNew<int>(GridElements,current_size,(current_size+max_number_elements));
 					if (!GridElementsRealloc){
 						noerr=0;
@@ -81,5 +82,5 @@
 	cleanup_and_return:
 	if(!noerr){
-		xfree((void**)&GridElements);
+		xDelete<int>(GridElements);
 	}
 	/*Allocate return pointers: */
@@ -128,5 +129,5 @@
 
 	/*Allocate segmentflags: */
-	riftsegments_uncompressed=(int*)xcalloc(nsegs*5,sizeof(int));
+	riftsegments_uncompressed=xNewZeroInit<int>(nsegs*5);
 
 	/*Find the segments that belong to a rift: they are the ones that see two elements. The other ones belong to a boundary 
@@ -165,5 +166,5 @@
 
 	/*Compress riftsegments_uncompressed:*/
-	riftsegments=(int*)xmalloc(nriftsegs*4*sizeof(int));
+	riftsegments=xNew<int>(nriftsegs*4);
 	counter=0;
 	for (i=0;i<nsegs;i++){
@@ -177,5 +178,5 @@
 	}
 
-	xfree((void**)&riftsegments_uncompressed);
+	xDelete<int>(riftsegments_uncompressed);
 	
 	/*Assign output pointers: */
@@ -202,5 +203,5 @@
 	/*Figure out the list of elements  that are on the same side of the rift. To do so, we start from one 
 	 * side of the rift and keep rotating in the same direction:*/
-	GridElementListOnOneSideOfRift=(int*)xmalloc(NumGridElements*sizeof(int));
+	GridElementListOnOneSideOfRift=xNew<int>(NumGridElements);
 	//bootstrap the GridElementListOnOneSideOfRift by filling elements from riftsegments: */
 	GridElementListOnOneSideOfRift[0]=*(riftsegments+4*segmentnumber+0); /*this one does not belong to the same side, but is just there 
@@ -241,5 +242,5 @@
 
 	/*Free ressources: */
-	xfree((void**)&GridElements);
+	xDelete<int>(GridElements);
 	/*Assign output pointers: */
 	*pNumGridElementListOnOneSideOfRift=NumGridElementListOnOneSideOfRift;
@@ -380,14 +381,14 @@
 
 	/*input: */
-	double* segments=NULL;
-	double* segmentmarkerlist=NULL;
+	double *segments          = NULL;
+	double *segmentmarkerlist = NULL;
 	int numsegs;
 	
 	/*output: */
-	int* riftsnumsegs=NULL;
-	double** riftssegments=NULL;
-	int new_numsegs;
-	double* new_segments=NULL;
-	double* new_segmentmarkers=NULL;
+	int      new_numsegs;
+	int     *riftsnumsegs       = NULL;
+	double **riftssegments      = NULL;
+	double  *new_segments       = NULL;
+	double  *new_segmentmarkers = NULL;
 
 	/*intermediary: */
@@ -406,6 +407,6 @@
 	/*Allocate new segments: */
 	new_numsegs=counter;
-	new_segments=(double*)xmalloc(new_numsegs*3*sizeof(double));
-	new_segmentmarkers=(double*)xmalloc(new_numsegs*sizeof(double));
+	new_segments=xNew<double>(new_numsegs*3);
+	new_segmentmarkers=xNew<double>(new_numsegs);
 
 	/*Copy new segments info : */
@@ -422,6 +423,6 @@
 
 	/*Now deal with rift segments: */
-	riftsnumsegs=(int*)xmalloc(numrifts*sizeof(int));
-	riftssegments=(double**)xmalloc(numrifts*sizeof(double*));
+	riftsnumsegs=xNew<int>(numrifts);
+	riftssegments=xNew<double*>(numrifts);
 	for (i=0;i<numrifts;i++){
 		/*Figure out how many segments for rift i: */
@@ -431,5 +432,5 @@
 		}
 		riftsnumsegs[i]=counter;
-		riftsegment=(double*)xmalloc(counter*3*sizeof(double));
+		riftsegment=xNew<double>(counter*3);
 		/*Copy new segments info :*/
 		counter=0;
@@ -446,5 +447,5 @@
 
 	/*Free ressources: */
-	xfree((void**)&segments);
+	xDelete<double>(segments);
 
 	/*Assign output pointers: */
@@ -465,6 +466,6 @@
 
 	/*output: */
-	int* riftsnumpairs=NULL;
-	double** riftspairs=NULL;
+	int     *riftsnumpairs = NULL;
+	double **riftspairs    = NULL;
 
 	/*intermediary :*/
@@ -474,11 +475,11 @@
 	int     node1,node2,node3,node4;
 
-	riftsnumpairs=(int*)xmalloc(numrifts*sizeof(int));
-	riftspairs=(double**)xmalloc(numrifts*sizeof(double*));
+	riftsnumpairs=xNew<int>(numrifts);
+	riftspairs=xNew<double*>(numrifts);
 	for (i=0;i<numrifts;i++){
 		segments=riftssegments[i];
 		numsegs=riftsnumsegments[i];
 		riftsnumpairs[i]=numsegs;
-		pairs=(double*)xmalloc(2*numsegs*sizeof(double));
+		pairs=xNew<double>(2*numsegs);
 		for (j=0;j<numsegs;j++){
 			*(pairs+2*j+0)=*(segments+3*j+2); //retrieve element to which this segment belongs.
@@ -500,9 +501,7 @@
 	}
 
-
 	/*Assign output pointers: */
 	*priftsnumpairs=riftsnumpairs;
 	*priftspairs=riftspairs;
-
 	return noerr;
 }/*}}}*/
@@ -522,17 +521,16 @@
 
 	/*intermediary: */
-	double* riftsegments=NULL;
-	double* riftpairs=NULL;
+	double *riftsegments = NULL;
+	double *riftpairs    = NULL;
 	int     node1,node2,node3,node4,temp_node;
 	double  el2;
 	int     newnods; //temporary # node counter.
 	double  xmin,ymin;
-	double* xreal=NULL;
-	double* yreal=NULL;
-	int* nodes=NULL;
-	int* mergingnodes=NULL;
+	double *xreal        = NULL;
+	double *yreal        = NULL;
+	int    *nodes        = NULL;
+	int    *mergingnodes = NULL;
 	int     max_size;
 	int     redundant;
-
 
 	/*Recover input: */
@@ -562,6 +560,6 @@
 		max_size+=rifts1numsegs[i];
 	}
-	nodes=(int*)xmalloc(max_size*sizeof(int));
-	mergingnodes=(int*)xmalloc(max_size*sizeof(int));
+	nodes=xNew<int>(max_size);
+	mergingnodes=xNew<int>(max_size);
 
 	/*Go through the rifts segments, and identify which node we are going to merge with its counterpart on the other side 
@@ -678,6 +676,6 @@
 		}
 	}
-	xfree((void**)&x); x=xreal;
-	xfree((void**)&y); y=yreal;
+	xDelete<double>(x); x=xreal;
+	xDelete<double>(y); y=yreal;
 
 	/*Assign output pointers:*/
@@ -688,5 +686,4 @@
 	*psegments=segments;
 	*pnumsegs=numsegs;
-
 	return noerr;
 }/*}}}*/
@@ -716,5 +713,4 @@
 	*priftflag=riftflag;
 	*pnumrifts=numrifts;
-
 	return noerr;
 }/*}}}*/
@@ -726,12 +722,12 @@
 
 	/*intermediary: */
-	double* riftsegments=NULL;
-	double* riftpairs=NULL;
+	double *riftsegments = NULL;
+	double *riftpairs    = NULL;
 	int numsegs;
 
 	/*ordering and copy: */
-	int*    order=NULL;
-	double* riftsegments_copy=NULL;
-	double* riftpairs_copy=NULL;
+	int    *order             = NULL;
+	double *riftsegments_copy = NULL;
+	double *riftpairs_copy    = NULL;
 
 	/*node and element manipulation: */
@@ -744,5 +740,5 @@
 
 	/*Allocate byproduct of this routine, riftstips: */
-	riftstips=(double*)xmalloc(numrifts*2*sizeof(double));
+	riftstips=xNew<double>(numrifts*2);
 
 	/*Go through all rifts: */
@@ -754,7 +750,7 @@
 		/*Allocate copy of riftsegments and riftpairs, 
 		 *as well as ordering vector: */
-		riftsegments_copy=(double*)xmalloc(numsegs*3*sizeof(double));
-		riftpairs_copy=(double*)xmalloc(numsegs*2*sizeof(double));
-		order=(int*)xmalloc(numsegs*sizeof(int));
+		riftsegments_copy=xNew<double>(numsegs*3);
+		riftpairs_copy=xNew<double>(numsegs*2);
+		order=xNew<int>(numsegs);
 
 		/*First find the tips, using the pairs. If a pair of elements has one node in common, this node is a rift tip: */
@@ -814,5 +810,4 @@
 		*(riftstips+2*i+0)=(double)tip1;
 		*(riftstips+2*i+1)=(double)tip2;
-
 
 		/*We have the two tips for this rift.  Go from tip1 to tip2, and figure out the order in which segments are sequential. 
@@ -865,7 +860,7 @@
 		}
 
-		xfree((void**)&order);
-		xfree((void**)&riftsegments_copy);
-		xfree((void**)&riftpairs_copy);
+		xDelete<int>(order);
+		xDelete<double>(riftsegments_copy);
+		xDelete<double>(riftpairs_copy);
 
 	}
@@ -887,7 +882,7 @@
 
 	/*output: */
-	double** riftspenaltypairs=NULL;
-	double*  riftpenaltypairs=NULL;
-	int*     riftsnumpenaltypairs=NULL;
+	double **riftspenaltypairs    = NULL;
+	double  *riftpenaltypairs     = NULL;
+	int     *riftsnumpenaltypairs = NULL;
 
 	/*intermediary: */
@@ -901,6 +896,6 @@
 
 	/*Allocate: */
-	riftspenaltypairs=(double**)xmalloc(numrifts*sizeof(double*));
-	riftsnumpenaltypairs=(int*)xmalloc(numrifts*sizeof(int));
+	riftspenaltypairs=xNew<double*>(numrifts);
+	riftsnumpenaltypairs=xNew<int>(numrifts);
 
 	for(i=0;i<numrifts;i++){
@@ -910,5 +905,5 @@
 
 		/*allocate riftpenaltypairs, and riftnumpenaltypairs: */
-		if((numsegs/2-1)!=0)riftpenaltypairs=(double*)xcalloc((numsegs/2-1)*RIFTPENALTYPAIRSWIDTH,sizeof(double));
+		if((numsegs/2-1)!=0)riftpenaltypairs=xNewZeroInit<double>((numsegs/2-1)*RIFTPENALTYPAIRSWIDTH);
 		
 		/*Go through only one flank of the rifts, not counting the tips: */
@@ -1006,11 +1001,8 @@
 		riftsnumpenaltypairs[i]=(numsegs/2-1);
 	}
-			
-
 
 	/*Assign output pointers: */
 	*priftspenaltypairs=riftspenaltypairs;
 	*priftsnumpenaltypairs=riftsnumpenaltypairs;
-
 	return noerr;
 }
@@ -1143,5 +1135,4 @@
 	*py=y;
 	*pnods=nods;
-
 	return noerr;
 }
Index: issm/branches/trunk-jpl-damage/src/c/shared/Wrapper/wrappershared.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/Wrapper/wrappershared.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/Wrapper/wrappershared.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _WRAPPER_SHARED_H_
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 int ModuleBoot(void);
Index: issm/branches/trunk-jpl-damage/src/c/shared/shared.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/shared/shared.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/shared/shared.h	(revision 12878)
@@ -6,17 +6,17 @@
 #define _SHARED_H_
 
-
 #include "Alloc/alloc.h"
-#include "Alloc/alloc_module.h"
+#include "Alloc/xNewDelete.h"
+#include "Bamg/shared.h"
+#include "Elements/elements.h"
 #include "Exceptions/exceptions.h"
 #include "Exp/exp.h"
+#include "Matrix/matrix.h"
+#include "MemOps/xMemCpy.h"
+#include "Numerics/numerics.h"
+#include "Sorting/sorting.h"
+#include "Sys/sys.h"
+#include "Threads/issm_threads.h"
 #include "TriMesh/trimesh.h"
-#include "Sorting/sorting.h"
-#include "Elements/elements.h"
-#include "Matrix/matrix.h"
-#include "Numerics/numerics.h"
-#include "Dofs/dofs.h"
-#include "Threads/issm_threads.h"
-#include "Bamg/shared.h"
 #include "Wrapper/wrappershared.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/solutions/AdjointCorePointerFromSolutionEnum.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/AdjointCorePointerFromSolutionEnum.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/AdjointCorePointerFromSolutionEnum.cpp	(revision 12878)
@@ -10,5 +10,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -35,5 +35,5 @@
 			break;
 		default:
-			_error_("No adjoint has been implemented for solution %s yet",EnumToStringx(solutiontype));
+			_error2_("No adjoint has been implemented for solution " << EnumToStringx(solutiontype) << " yet");
 			break;
 	}
Index: issm/branches/trunk-jpl-damage/src/c/solutions/AnalysisConfiguration.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/AnalysisConfiguration.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/AnalysisConfiguration.cpp	(revision 12878)
@@ -10,5 +10,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -29,5 +29,5 @@
 		case DiagnosticSolutionEnum:
 			numanalyses=5;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=DiagnosticHorizAnalysisEnum;
 			analyses[1]=DiagnosticVertAnalysisEnum;
@@ -39,5 +39,5 @@
 		case SteadystateSolutionEnum:
 			numanalyses=8;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=DiagnosticHorizAnalysisEnum;
 			analyses[1]=DiagnosticVertAnalysisEnum;
@@ -52,5 +52,5 @@
 		case ThermalSolutionEnum:
 			numanalyses=2;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=ThermalAnalysisEnum;
 			analyses[1]=MeltingAnalysisEnum;
@@ -59,5 +59,5 @@
 		case EnthalpySolutionEnum:
 			numanalyses=1;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=EnthalpyAnalysisEnum;
 			break;
@@ -65,5 +65,5 @@
 		case HydrologySolutionEnum:
 			numanalyses=3;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=HydrologyAnalysisEnum;
 			analyses[1]=SurfaceSlopeAnalysisEnum;
@@ -73,5 +73,5 @@
 		case PrognosticSolutionEnum:
 			numanalyses=1;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=PrognosticAnalysisEnum;
 			break;
@@ -79,5 +79,5 @@
 		case BalancethicknessSolutionEnum:
 			numanalyses=1;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=BalancethicknessAnalysisEnum;
 			break;
@@ -85,5 +85,5 @@
 		case SurfaceSlopeSolutionEnum:
 			numanalyses=1;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=SurfaceSlopeAnalysisEnum;
 			break;
@@ -91,5 +91,5 @@
 		case BedSlopeSolutionEnum:
 			numanalyses=1;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=BedSlopeAnalysisEnum;
 			break;
@@ -97,5 +97,5 @@
 		case TransientSolutionEnum:
 			numanalyses=9;
-			analyses=(int*)xmalloc(numanalyses*sizeof(int));
+			analyses=xNew<int>(numanalyses);
 			analyses[0]=DiagnosticHorizAnalysisEnum;
 			analyses[1]=DiagnosticVertAnalysisEnum;
@@ -110,5 +110,5 @@
 		
 		default:
-			_error_("%s%s%s"," solution type: ",EnumToStringx(solutiontype)," not supported yet!");
+			_error2_("solution type: " << EnumToStringx(solutiontype) << " not supported yet!");
 			break;
 	}
@@ -117,4 +117,4 @@
 	if(pnumanalyses) *pnumanalyses=numanalyses;
 	if(panalyses)    *panalyses=analyses;
-	else              xfree((void**)&analyses);
+	else              xDelete<int>(analyses);
 }
Index: issm/branches/trunk-jpl-damage/src/c/solutions/CorePointerFromSolutionEnum.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solutions/CorePointerFromSolutionEnum.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solutions/CorePointerFromSolutionEnum.cpp	(revision 12878)
@@ -10,5 +10,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../shared/shared.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -29,5 +29,5 @@
 			solutioncore=&diagnostic_core;
 			#else
-			_error_("ISSM was not compiled with diagnostic capabilities. Exiting");
+			_error2_("ISSM was not compiled with diagnostic capabilities. Exiting");
 			#endif
 			break;
@@ -36,5 +36,5 @@
 			solutioncore=&steadystate_core;
 			#else
-			_error_("ISSM was not compiled with steady state capabilities. Exiting");
+			_error2_("ISSM was not compiled with steady state capabilities. Exiting");
 			#endif
 			break;
@@ -43,5 +43,5 @@
 			solutioncore=&thermal_core;
 			#else
-			_error_("ISSM was not compiled with thermal capabilities. Exiting");
+			_error2_("ISSM was not compiled with thermal capabilities. Exiting");
 			#endif
 			break;
@@ -50,5 +50,5 @@
 			solutioncore=&enthalpy_core;
 			#else
-			_error_("ISSM was not compiled with thermal capabilities. Exiting");
+			_error2_("ISSM was not compiled with thermal capabilities. Exiting");
 			#endif
 			break;
@@ -57,5 +57,5 @@
 			solutioncore=&balancethickness_core;
 			#else
-			_error_("ISSM was not compiled with balanced capabilities. Exiting");
+			_error2_("ISSM was not compiled with balanced capabilities. Exiting");
 			#endif
 			break;
@@ -64,5 +64,5 @@
 			solutioncore=&hydrology_core;
 			#else
-			_error_("ISSM was not compiled with hydrology capabilities. Exiting");
+			_error2_("ISSM was not compiled with hydrology capabilities. Exiting");
 			#endif
 			break;
@@ -71,5 +71,5 @@
 			solutioncore=&surfaceslope_core;
 			#else
-			_error_("ISSM was not compiled with slope capabilities. Exiting");
+			_error2_("ISSM was not compiled with slope capabilities. Exiting");
 			#endif
 			break;
@@ -78,5 +78,5 @@
 			solutioncore=&bedslope_core;
 			#else
-			_error_("ISSM was not compiled with slope capabilities. Exiting");
+			_error2_("ISSM was not compiled with slope capabilities. Exiting");
 			#endif
 			break;
@@ -85,5 +85,5 @@
 			solutioncore=&transient_core;
 			#else
-			_error_("ISSM was not compiled with transient capabilities. Exiting");
+			_error2_("ISSM was not compiled with transient capabilities. Exiting");
 			#endif
 			break;
@@ -92,9 +92,9 @@
 			solutioncore=&prognostic_core;
 			#else
-			_error_("ISSM was not compiled with prognostic capabilities. Exiting");
+			_error2_("ISSM was not compiled with prognostic capabilities. Exiting");
 			#endif
 			break;
 		default:
-			_error_("%s%s%s"," solution type: ",EnumToStringx(solutiontype)," not supported yet!");
+			_error2_("solution type: " << EnumToStringx(solutiontype) << " not supported yet!");
 			break;
 	}
